#include <AccelStepper.h>
#define HALFSTEP 4
//motor derecha
#define motorPin1 4 //pin IN1 del driver ULN2003
#define motorPin2 5 // pin IN2 del driver ULN2003
#define motorPin3 6 // pin IN3 del driver ULN2003
#define motorPin4 7 // pin IN4 del driver ULN2003

//motor izquierda
#define motorPin5 8 // pin IN1 del driver ULN2003
#define motorPin6 9 // pin IN2 del driver ULN2003
#define motorPin7 10 //pin IN3 del driver ULN2003
#define motorPin8 11 //pin IN4 del driver ULN2003
// Define dos objetos de motor paso a paso
AccelStepper stepper1 (HALFSTEP, motorPin1, motorPin3, motorPin2, motorPin4);
AccelStepper stepper2 (HALFSTEP, motorPin5, motorPin7, motorPin6, motorPin8);

//PARAMETROS MATRIZ
char matriz [30];
int i = 0; //contador  

//asignación de pines de entrada a los pulsadores

int Pizquierda=A5; Pulsador giro izquierda
int Padelante=A4;
int Pderecha=A2;
int Patras=A1; 
int Pborra=A0;
int Pactiva=A3;

 void setup () {
Serial.begin(9600);
stepper1. setSpeed ( 600 );
stepper1. setAcceleration ( 200 );//con aceleraciones superiores la rueda se atranca
stepper1. setMaxSpeed ( 1000 );
stepper2. setSpeed (600 );
stepper2. setAcceleration ( 200 );
stepper2. setMaxSpeed ( 1000 );
// 2048 pasos equivale a media vuelta

// PULSADORES
  pinMode(Pizquierda,INPUT);
  pinMode(Padelante,INPUT);
  pinMode(Pderecha,INPUT);
  pinMode(Patras,INPUT);
  pinMode(Pborra,INPUT);
  pinMode(Pactiva,INPUT);

}

 void loop () {
   
     //bucle matriz

                           Serial.print("i=");
                           Serial.println(i);
                           Serial.print("x=");
                           Serial.println(matriz[i]); // a efectos de visualización en el monitor serie
               
           if ( digitalRead(Padelante)==HIGH )//pulsador para avanzar
                         {
                              i=i+1;              //cuenta los tramos que avanza
                              matriz[i]='A';     //matriz que almacena el numero de veces que avanza
                             delay(500);         //retraso para introducir pulsos
                 } 
          if ( digitalRead(Pizquierda)==HIGH )//pulsador para retroceder
                 {
                    i=i+1;
                     matriz[i]='I';
                     delay(500);
                 }   
          if ( digitalRead(Patras)==HIGH )//pulsador para retroceder
                  {
                       i=i+1;
                       matriz[i]='R';
                       delay(500);
                 }         
          if ( digitalRead(Pderecha)==HIGH )//pulsador para giro derecha
                 {
                    i=i+1;
                    matriz[i]='D';
                   delay(500);
                 } 
        if ( digitalRead(Pactiva)==HIGH) //pulsador para activar el movimiento
             {      
                      for (int i=0;i<2;i++)      //ciclo de conteo de los pulsos introducidos
                        { 
                                switch(matriz[i])   // lee el valor de cada celda de la matríz o y lo envia al caso correspondiente 
                                {
                                case 'A'://avanza 
                                ADelante();
                                break;
                                
                                case 'I':
                                IZquierda();
                                break;
                                
                                case 'D':
                                DErecha();
                                break;
                        
                                case 'R':
                                ATras();
                                break;
                                }
                         matriz[i]=0;
                         i=0;  
                        }

             }
                        stepper1.run ();
                        stepper2.run ();  
}

void  ADelante () 
{
      if (stepper1.distanceToGo()==0)
         {
            stepper1. move( 2048 );
            stepper2. move(- 2048 );
           
          }
 }
void  IZquierda ()
{

      if (stepper1.distanceToGo()==0)
          {
            stepper1. move (500 );
            stepper2. move (500 );
          }
}

void  ATras () 
{
    if (stepper1.distanceToGo()==0)
        {
          stepper1. move ( -2048 );
          stepper2. move ( 2048);
         }
}

void  DErecha ()
{
      if (stepper1.distanceToGo()==0)
          {
              stepper1. move ( -500 );
              stepper2. move (- 500);
          }
}
    
